﻿using System;
using System.Threading;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace KeyShop
{
    public class clsMain
    {
        public clsMain()
        {
            mySettings_ = new clsSettings();
        }

        //########################################################
        //
        //  private variable
        //
        //########################################################

        private clsSettings mySettings_;


        //########################################################
        //
        //  public function
        //
        //########################################################

        public string xCreatePassword()
        {
            return _CreatePassword();
        }


        //########################################################
        //
        //  private function
        //
        //########################################################

        private string _CreatePassword()
        {
            int 文字数 = 0;
            int 生成数 = 0;
            bool 記号使用 = false;
            bool 日時使用 = false;
            string 区切り文字 = "";

            string ret = "";

            try
            {
                文字数 = Convert.ToInt32(mySettings_.xGetAttribute("文字列", "文字数"));
                生成数 = Convert.ToInt32(mySettings_.xGetAttribute("文字列", "生成数"));
                if (mySettings_.xGetAttribute("文字列", "記号使用").ToLower() == "yes")
                {
                    記号使用 = true;
                }
                if (mySettings_.xGetAttribute("文字列", "日時使用").ToLower() == "yes")
                {
                    日時使用 = true;
                }
                区切り文字 = mySettings_.xGetAttribute("転送方法", "区切り文字");
                if (区切り文字 == "改行")
                {
                    区切り文字 = Environment.NewLine;
                }
                else if (区切り文字 == "カンマ")
                {
                    区切り文字 = ",";
                }
                else if (区切り文字 == "タブ")
                {
                    区切り文字 = "\t";
                }

                ret = "";
                for (int i = 0; i < 生成数; i++)
                {
                    if (i > 0) ret += 区切り文字;
                    ret += _GetRandomStrings(文字数, 記号使用, 日時使用);
                    Thread.Sleep(1);

                }
            }
            catch (Exception ex)
            {
                throw ex;
            }

            Clipboard.SetText(ret);

            return ret;
        }

        private string _GetRandomStrings(int 文字数, bool 記号可, bool 日時付加)
        {
            if (文字数 == 0)
            {
                return "";
            }

            string ret = "";
            int intRandom = 0;

            Random random = new Random();
            for (int i = 0; i < 文字数; i++)
            {
                bool flg = false;
                while (flg == false)
                {
                    Thread.Sleep(0);

                    if (記号可 == true)
                    {
                        intRandom = random.Next(33, 122);
                    }
                    else
                    {
                        intRandom = random.Next(48, 122);
                    }
                    if (((intRandom == 33) || (intRandom == 35) || (intRandom == 36)) ||
                        ((intRandom >= 48) && (intRandom <= 57)) ||
                        ((intRandom >= 65) && (intRandom <= 90)) ||
                        ((intRandom >= 97) && (intRandom <= 122)))
                    {
                        ret += Convert.ToChar(intRandom).ToString();
                        flg = true;
                    }
                }
            }
            random = null;

            if (日時付加)
            {
                ret = DateTime.Now.ToString("yyyyMMddHHmmss") + ret;
            }

            return ret;
        }



    }
}
